/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-ethercat-trigger-controllers-1.10.8-0raring-20150330-0044/srv/SetWaveform.srv
 *
 */


#ifndef ETHERCAT_TRIGGER_CONTROLLERS_MESSAGE_SETWAVEFORMREQUEST_H
#define ETHERCAT_TRIGGER_CONTROLLERS_MESSAGE_SETWAVEFORMREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace ethercat_trigger_controllers
{
template <class ContainerAllocator>
struct SetWaveformRequest_
{
  typedef SetWaveformRequest_<ContainerAllocator> Type;

  SetWaveformRequest_()
    : rep_rate(0.0)
    , phase(0.0)
    , duty_cycle(0.0)
    , running(0)
    , active_low(0)
    , pulsed(0)  {
    }
  SetWaveformRequest_(const ContainerAllocator& _alloc)
    : rep_rate(0.0)
    , phase(0.0)
    , duty_cycle(0.0)
    , running(0)
    , active_low(0)
    , pulsed(0)  {
    }



   typedef double _rep_rate_type;
  _rep_rate_type rep_rate;

   typedef double _phase_type;
  _phase_type phase;

   typedef double _duty_cycle_type;
  _duty_cycle_type duty_cycle;

   typedef int32_t _running_type;
  _running_type running;

   typedef int32_t _active_low_type;
  _active_low_type active_low;

   typedef int32_t _pulsed_type;
  _pulsed_type pulsed;




  typedef boost::shared_ptr< ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct SetWaveformRequest_

typedef ::ethercat_trigger_controllers::SetWaveformRequest_<std::allocator<void> > SetWaveformRequest;

typedef boost::shared_ptr< ::ethercat_trigger_controllers::SetWaveformRequest > SetWaveformRequestPtr;
typedef boost::shared_ptr< ::ethercat_trigger_controllers::SetWaveformRequest const> SetWaveformRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace ethercat_trigger_controllers

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'ethercat_trigger_controllers': ['/tmp/buildd/ros-hydro-ethercat-trigger-controllers-1.10.8-0raring-20150330-0044/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "988450e1ddd386f3967c381c19b2330c";
  }

  static const char* value(const ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x988450e1ddd386f3ULL;
  static const uint64_t static_value2 = 0x967c381c19b2330cULL;
};

template<class ContainerAllocator>
struct DataType< ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ethercat_trigger_controllers/SetWaveformRequest";
  }

  static const char* value(const ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "float64 rep_rate\n\
float64 phase\n\
float64 duty_cycle\n\
int32 running\n\
int32 active_low\n\
int32 pulsed\n\
";
  }

  static const char* value(const ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.rep_rate);
      stream.next(m.phase);
      stream.next(m.duty_cycle);
      stream.next(m.running);
      stream.next(m.active_low);
      stream.next(m.pulsed);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct SetWaveformRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::ethercat_trigger_controllers::SetWaveformRequest_<ContainerAllocator>& v)
  {
    s << indent << "rep_rate: ";
    Printer<double>::stream(s, indent + "  ", v.rep_rate);
    s << indent << "phase: ";
    Printer<double>::stream(s, indent + "  ", v.phase);
    s << indent << "duty_cycle: ";
    Printer<double>::stream(s, indent + "  ", v.duty_cycle);
    s << indent << "running: ";
    Printer<int32_t>::stream(s, indent + "  ", v.running);
    s << indent << "active_low: ";
    Printer<int32_t>::stream(s, indent + "  ", v.active_low);
    s << indent << "pulsed: ";
    Printer<int32_t>::stream(s, indent + "  ", v.pulsed);
  }
};

} // namespace message_operations
} // namespace ros

#endif // ETHERCAT_TRIGGER_CONTROLLERS_MESSAGE_SETWAVEFORMREQUEST_H
